/*
 * Tugas Besar 3 WBD - AMEN
 */

'use strict'

const express = require('express')

const cloud = require('../service/cloud')
const relay = require('../service/relay')

let app = express.Router()

// Administration.

app.post('/:id/token', function (req, res) {
  let id = req.params.id
  let token = req.body.token

  cloud.register(id, token)

  res.json({ status: 'ok' })
})

app.delete('/:id', function (req, res) {
  let id = req.params.id

  cloud.unregister(id)
  relay.disassociate(id)

  res.json({ status: 'ok' })
})

// Messaging.

app.post('/:id/message', async function (req, res) {
  let id = req.params.id
  let message = req.body.message

  try {
    await relay.sendAsync(id, message)

    res.json({ status: 'ok' })
  } catch (e) {
    console.log(e)

    res.json({
      status: 'error',
      message: e.message
    })
  }
})

module.exports = app
